#include <stdio.h>
#include <unistd.h>                 /* getcwd */

#include "mess.h"
#include "xmame.h"                  /* OSD_OK */
#include "devices.h"                /* game_driver */

#include "gp2x.h"
#include "gp2x_fs_dlg.h"
#include "gp2x_sdl.h"
#include "gp2x_opt.h"
#include "gp2x_sysdep_vkeyb.h"

///////////////////////////////////

void
gp2x_run_hook( game_driver* drv )
{
    char title[ 128 ];
    char pwd[ 128 ];

    SDL_Surface* screen = NULL;
    TTF_Font* font   = NULL;

    if ( drv->name )
    {
        if (    !mame_stricmp( drv->name, "a7800" ) 
             || !mame_stricmp( drv->name, "a7800p" )
             || !mame_stricmp( drv->name, "arcadia" )
             || !mame_stricmp( drv->name, "odyssey2" ) )
        {

            if ( options.image_count != 0 )     /* nothing to do, cart specified */
                return;

            /*  
             *  Some systems won't 'boot' without a cart and we don't have the luxury of a file picker
             *  before launching
             */

            screen = gp2x_init_sdl();

            font = gp2x_load_ttf_font( "res/fs_dlg.ttf", 11 );

            sprintf( title, "Please select an initial cartridge for %s", drv->name );

            getcwd( pwd, 128 );

            char* filename = gp2x_show_file_selector( screen, font, pwd, title );

            if ( filename )
            {
                options.image_count = 1;
                options.image_files[0].type = IO_CARTSLOT;
                options.image_files[0].name = strdup( filename );
            }

            gp2x_fini_sdl();
        }

        /* Does a7800 need it?? */

        gp2x_cur_opts.vkeyb = &pc_keyboard;

        if ( !mame_stricmp( drv->name, "coleco" ) )
            gp2x_cur_opts.vkeyb = &coleco_keyboard;

        if ( !mame_stricmp( drv->name, "coco2" ) )
            gp2x_cur_opts.vkeyb->font_size = 22;

        if ( !mame_stricmp( drv->name, "coco3" ) )
            gp2x_cur_opts.vkeyb->font_size = 22;

        if ( !mame_stricmp( drv->name, "apple2" ) )
            gp2x_cur_opts.vkeyb->font_size = 22;

        if ( !mame_stricmp( drv->name, "apple2c" ) )
            gp2x_cur_opts.vkeyb->font_size = 22;

        if ( !mame_stricmp( drv->name, "apple2e" ) )
            gp2x_cur_opts.vkeyb->font_size = 22;

        if ( !mame_stricmp( drv->name, "arcadia" ) )
            gp2x_cur_opts.vkeyb->font_size = 22;
    }
}

///////////////////////////////////

void
gp2x_exit_hook( void )
{
}
