#include "../src/unix/effect.h"
#include "../src/unix/sysdep/sysdep_palette.h"

///////////////////////////////////

__inline__ void 
blit_normal_line_1_16_16 (unsigned short *src, unsigned short *end, unsigned short *dst, unsigned int *lookup)
{
	register unsigned int count = end - src;

	while ( count > 0 )
	{
        *(dst  ) = *( lookup + (*(src  )) );
        *(dst+1) = *( lookup + (*(src+1)) );
        *(dst+2) = *( lookup + (*(src+2)) );
        *(dst+3) = *( lookup + (*(src+3)) );

		src   += 4;
		dst   += 4;
		count -= 4;
	}
}

#if 0
///////////////////////////////////

static __inline__ void 
blit_normal_line_2_16_16 (unsigned short *src, unsigned short *end, unsigned short *dst, unsigned int *lookup)
{
	register unsigned int count = end - src;

    fprintf( stdout, "gp2x: in blit_normal_line_2_16_16\n" );
    fflush( stdout );

	while ( count > 0 )
	{
        *(dst+1) = *(dst  ) = *( lookup + (*(src  )) );
        *(dst+3) = *(dst+2) = *( lookup + (*(src+1)) );
        *(dst+5) = *(dst+4) = *( lookup + (*(src+2)) );
        *(dst+7) = *(dst+6) = *( lookup + (*(src+3)) );

		src   += 4;
		dst   += 8;
		count -= 4;
	}
}

///////////////////////////////////

void blit_normal_16_16_alt(mame_bitmap *bitmap, rectangle *vis_in_dest_out, rectangle *dirty_area, struct sysdep_palette_struct *palette, unsigned char *dest, int dest_width);

///////////////////////////////////

void 
blit_normal_16_16_alt(mame_bitmap *bitmap, rectangle *vis_in_dest_out, rectangle *dirty_area, struct sysdep_palette_struct *palette, unsigned char *dest, int dest_width) 
{ 
    int y, count, yarbsize;
	unsigned short *line_dest; 

    fprintf( stdout, "gp2x: in blit_normal_16_16\n" );
    fflush( stdout );

    sysdep_display_check_bounds(bitmap, vis_in_dest_out, dirty_area, 3);

    line_dest = (unsigned short *)(dest + ( (vis_in_dest_out->min_y*dest_width + vis_in_dest_out->min_x) << 1 ));

    /* NOTE: This is the routine that is used for SW surfaces and not rotated,
     *       which currently is everyting.
     */
    
	count = dirty_area->max_y - dirty_area->min_y;
	y = dirty_area->min_y;

	if ( sysdep_display_params.widthscale == 2 )
	{
		while ( count > 0 )
		{
            blit_normal_line_2_16_16( ((unsigned short *)(bitmap->line[y])) + dirty_area->min_x, ((unsigned short *)(bitmap->line[y])) + dirty_area->max_x, (unsigned short *)line_dest, palette->lookup);

            line_dest += dest_width;
            y         += 1;
            count     -= 1;
		}
	}

	else
	{
		while ( count > 0 )
		{
            blit_normal_line_1_16_16( ((unsigned short *)(bitmap->line[y])) + dirty_area->min_x, ((unsigned short *)(bitmap->line[y])) + dirty_area->max_x, (unsigned short *)line_dest, palette->lookup);

            line_dest += dest_width;
            y         += 1;
            count     -= 1;
		}
	}
}
#endif
